com.holonplatform.vaadin.flow.navigator

## Interface NavigationParameterMapper

- All Known Implementing Classes:
    DefaultNavigationParameterMapper

      public interface NavigationParameterMapper

  Navigation parameters value serializer and deserializer.
  Since:
    5.2.0

- - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `<T> List<T>` | `deserialize(Class<T> type, List<String> values)` Deserialize given parameter `values`.
    `default <T> Optional<T>` | `deserialize(Class<T> type, String value)` Deserialize given parameter `value`.
    `static NavigationParameterMapper` | `get()` Get the default `NavigationParameterMapper`.
    `List<String>` | `serialize(Object value)` Serialize given parameter `value`.

- - ### Method Detail

    - #### serialize

          List<String> serialize(Object value)
                          throws InvalidNavigationParameterException

      Serialize given parameter `value`.
      Parameters:
        `value` - Parameter value (may be null)
      Returns:
        A list of serialized parameter values, empty if none
      Throws:
        `InvalidNavigationParameterException` - If an error occurred

    - #### deserialize

          <T> List<T> deserialize(Class<T> type,
                                  List<String> values)
                           throws InvalidNavigationParameterException

      Deserialize given parameter `values`.
      Type Parameters:
        `T` - Parameter type
      Parameters:
        `type` - Parameter type (not null)
        `values` - The parameter values, empty if none
      Returns:
        A list of deserialized parameter values, empty if none
      Throws:
        `InvalidNavigationParameterException` - If an error occurred

    - #### deserialize

          default <T> Optional<T> deserialize(Class<T> type,
                                              String value)
                                       throws InvalidNavigationParameterException

      Deserialize given parameter `value`.
      Type Parameters:
        `T` - Parameter type
      Parameters:
        `type` - Parameter type (not null)
        `value` - Parameter value (may be null)
      Returns:
        Optional deserialized parameter value
      Throws:
        `InvalidNavigationParameterException` - If an error occurred

    - #### get

          static NavigationParameterMapper get()

      Get the default `NavigationParameterMapper`.
      Returns:
        the default `NavigationParameterMapper`

Copyright © 2019 The Holon Platform. All rights reserved.